<template>
    <div>
        <div class="search-bar-header">
            <#if ctrl.getQuickSearchMode() gt 0>
            <i-input v-model="query" placeholder="<#if ctrl.getPSSearchBarQuickSearchs()??><#list ctrl.getPSSearchBarQuickSearchs() as search><#if search_index gt 0>,</#if><#if search.getPSDEField()??>${search.getPSDEField().getLogicName()}</#if></#list></#if>" style="<#if ctrl.getQuickSearchWidth() gt 0>width: ${ctrl.getQuickSearchWidth()?c}px;</#if>"></i-input>
            </#if>
            <div class="search-bar-action">
                <i-button title="搜索" @click="onSearch"><i class="fa fa-search" aria-hidden="true"></i></i-button>
                <i-button title="添加" v-if="filterFields.length > 0" @click="onAdd"><i class="fa fa-plus" aria-hidden="true"></i></i-button>
                <i-button title="保存" @click="onSave"><i class="fa fa-floppy-o" aria-hidden="true"></i></i-button>
                <i-button title="重置" @click="onReset"><i class="fa fa-repeat" aria-hidden="true"></i></i-button>
            </div>
        </div>
        <div v-if="filterFields.length > 0" class="filter-group">
            <template v-for="(item, index) of filterItems">
                <filter-item :key="index" :data="item" :filterFields="filterFields" @remove="onRemove(index)">
                    <template slot-scope="{ data }">
                        <template v-if="!data.field">
                            <i-input></i-input>
                        </template>
                        <#if ctrl.getPSSearchBarFilters()??>
                        <#list ctrl.getPSSearchBarFilters() as filter>
                        <template v-if="Object.is(data.field, '${filter.getName()}')">
                            ${P.getEditorCode(filter, "EDITOR.vue").code}
                        </template>
                        </#list>
                        </#if>
                    </template>
                </filter-item>
            </template>
        </div>
    </div>
</template>
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 快速搜索值
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public query: string = '';

    /**
     * 过滤属性集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    get filterFields() {
        return Object.values(this.detailsModel);
    }

    /**
     * 过滤属性模型集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public detailsModel: any = {
        <#if ctrl.getPSSearchBarFilters()??>
        <#list ctrl.getPSSearchBarFilters() as filter>
        '${filter.getName()}': {
            label: '${filter.getCaption()}',
            name: '${filter.getName()}',
            prop: '<#if filter.getPSDEField()??>${filter.getPSDEField().getCodeName()?lower_case}<#else>${filter.getName()}</#if>',
            disabled: false
        },
        </#list>
        </#if>
    };

    /**
     * 过滤项集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public filterItems: any[] = [];

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getData(): any {
        let data: any = {};
        if(!Object.is(this.query, '')) {
            Object.assign(data, { query: this.query })
        }
        if(this.filterFields.length > 0 && this.filterItems.length > 0) {
            Object.assign(data, { filter: this.getFilter() })
        }
        return data;
    }

    /**
     * 获取filter
     *
     * @return {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getFilter(): any {
        
    }

    /**
     * 删除过滤项
     *
     * @return {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onRemove(index: number) {
        this.filterItems.splice(index, 1);
    } 

    /**
     * 添加过滤项
     *
     * @return {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onAdd() {
        this.filterItems.push({ group: '1' });
    } 

    /**
     * 搜索
     *
     * @return {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onSearch() {
        this.$emit('search', this.getData());
    }

    /**
     * 保存
     *
     * @return {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onSave() {

    }

    /**
     * 重置
     *
     * @return {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onReset() {
        this.query = '';
        this.filterItems = [];
    }
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>